diff --git a/sys/compat/mach/mach_vm.c b/sys/compat/mach/mach_vm.c
index b495add..aeb3588 100644
--- a/sys/compat/mach/mach_vm.c
+++ b/sys/compat/mach/mach_vm.c
@@ -1,5 +1,3 @@
-/*	$NetBSD: mach_vm.c,v 1.62 2010/06/24 13:03:07 hannken Exp $ */
-
 /*-
  * Copyright (c) 2002-2003, 2008 The NetBSD Foundation, Inc.
  * All rights reserved.
@@ -30,7 +28,7 @@
  */
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: mach_vm.c,v 1.62 2010/06/24 13:03:07 hannken Exp $");
+__FBSDID("$FreeBSD$");
 
 #include <sys/types.h>
 #include <sys/param.h>
@@ -44,11 +42,11 @@ __KERNEL_RCSID(0, "$NetBSD: mach_vm.c,v 1.62 2010/06/24 13:03:07 hannken Exp $")
 #include <sys/filedesc.h>
 #include <sys/ktrace.h>
 #include <sys/exec.h>
-#include <sys/syscallargs.h>
+#include <sys/sysproto.h>
 
-#include <uvm/uvm_prot.h>
-#include <uvm/uvm_map.h>
-#include <uvm/uvm_extern.h>
+#include <vm/pmap.h>
+#include <vm/vm_map.h>
+#include <vm/vm_extern.h>
 
 #include <compat/mach/mach_types.h>
 #include <compat/mach/mach_message.h>
@@ -57,7 +55,7 @@ __KERNEL_RCSID(0, "$NetBSD: mach_vm.c,v 1.62 2010/06/24 13:03:07 hannken Exp $")
 #include <compat/mach/mach_errno.h>
 #include <compat/mach/mach_port.h>
 #include <compat/mach/mach_services.h>
-#include <compat/mach/mach_syscallargs.h>
+#include <compat/mach/mach_proto.h>
 
 int
 mach_vm_map(struct mach_trap_args *args)
@@ -65,10 +63,10 @@ mach_vm_map(struct mach_trap_args *args)
 	mach_vm_map_request_t *req = args->smsg;
 	mach_vm_map_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
-	struct lwp *tl = args->tl;
-	struct proc *tp = tl->l_proc;
+	struct thread *ttd = args->ttd;
+	struct proc *tp = ttd->td_proc;
 	struct sys_mmap_args cup;
-	vaddr_t addr;
+	vm_offset_t addr;
 	int error, flags;
 	void *ret;
 
@@ -95,10 +93,10 @@ mach_vm_map(struct mach_trap_args *args)
 		req->req_mask += 1;
 
 	if (req->req_flags & MACH_VM_FLAGS_ANYWHERE) {
-		SCARG(&cup, flags) = MAP_ANON;
+		cup.flags = MAP_ANON;
 		flags = 0;
 	} else {
-		SCARG(&cup, flags) = MAP_ANON | MAP_FIXED;
+		cup.flags = MAP_ANON | MAP_FIXED;
 		flags = MAP_FIXED;
 	}
 
@@ -107,7 +105,7 @@ mach_vm_map(struct mach_trap_args *args)
 	 * requested alignement.
 	 */
 	vm_map_lock(&tp->p_vmspace->vm_map);
-	ret = uvm_map_findspace(&tp->p_vmspace->vm_map,
+	ret = vm_map_findspace(&tp->p_vmspace->vm_map,
 	    trunc_page(req->req_address), req->req_size, &addr,
 	    NULL, 0, req->req_mask, flags);
 	vm_map_unlock(&tp->p_vmspace->vm_map);
@@ -117,27 +115,27 @@ mach_vm_map(struct mach_trap_args *args)
 
 	switch(req->req_inherance) {
 	case MACH_VM_INHERIT_SHARE:
-		SCARG(&cup, flags) |= MAP_INHERIT;
+		cup.flags |= MAP_INHERIT_SHARE;
 		break;
 	case MACH_VM_INHERIT_COPY:
-		SCARG(&cup, flags) |= MAP_COPY;
+		cup.flags) |= MAP_COPY_ON_WRITE;
 		break;
 	case MACH_VM_INHERIT_NONE:
 		break;
 	case MACH_VM_INHERIT_DONATE_COPY:
 	default:
-		uprintf("mach_vm_map: unsupported inherance flag %d\n",
+		uprintf("mach_vm_map: unsupported inheritance flag %d\n",
 		    req->req_inherance);
 		break;
 	}
 
-	SCARG(&cup, addr) = (void *)addr;
-	SCARG(&cup, len) = req->req_size;
-	SCARG(&cup, prot) = req->req_cur_protection;
-	SCARG(&cup, fd) = -1;		/* XXX For now, no object mapping */
-	SCARG(&cup, pos) = req->req_offset;
+	cup.addr) = (void *)addr;
+	cup.len) = req->req_size;
+	cup.prot) = req->req_cur_protection;
+	cup.fd) = -1;		/* XXX For now, no object mapping */
+	cup.pos) = req->req_offset;
 
-	if ((error = sys_mmap(tl, &cup, &rep->rep_retval)) != 0)
+	if ((error = sys_mmap(ttd, &cup, &rep->rep_retval)) != 0)
 		return mach_msg_error(args, error);
 
 	*msglen = sizeof(*rep);
@@ -153,10 +151,10 @@ mach_vm_allocate(struct mach_trap_args *args)
 	mach_vm_allocate_request_t *req = args->smsg;
 	mach_vm_allocate_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
-	struct lwp *tl = args->tl;
-	struct proc *tp = tl->l_proc;
+	struct thread *ttd = args->ttd;
+	struct proc *tp = ttd->td_proc;
 	struct sys_mmap_args cup;
-	vaddr_t addr;
+	vm_offset_t addr;
 	size_t size;
 	int error;
 
@@ -195,16 +193,16 @@ mach_vm_allocate(struct mach_trap_args *args)
 	if (size == 0)
 		goto out;
 
-	SCARG(&cup, addr) = (void *)addr;
-	SCARG(&cup, len) = size;
-	SCARG(&cup, prot) = PROT_READ | PROT_WRITE;
-	SCARG(&cup, flags) = MAP_ANON;
+	cup.addr) = (void *)addr;
+	cup.len) = size;
+	cup.prot) = PROT_READ | PROT_WRITE;
+	cup.flags) = MAP_ANON;
 	if ((req->req_flags & MACH_VM_FLAGS_ANYWHERE) == 0)
-		SCARG(&cup, flags) |= MAP_FIXED;
-	SCARG(&cup, fd) = -1;
-	SCARG(&cup, pos) = 0;
+		cup.flags) |= MAP_FIXED;
+	cup.fd) = -1;
+	cup.pos) = 0;
 
-	if ((error = sys_mmap(tl, &cup, &rep->rep_address)) != 0)
+	if ((error = sys_mmap(ttd, &cup, &rep->rep_address)) != 0)
 		return mach_msg_error(args, error);
 #ifdef DEBUG_MACH_VM
 	printf("vm_allocate: success at %p\n", (void *)rep->rep_address);
@@ -227,7 +225,7 @@ mach_vm_deallocate(struct mach_trap_args *args)
 	mach_vm_deallocate_request_t *req = args->smsg;
 	mach_vm_deallocate_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
-	struct lwp *tl = args->tl;
+	struct thread *ttd = args->ttd;
 	struct sys_munmap_args cup;
 	int error;
 
@@ -236,10 +234,10 @@ mach_vm_deallocate(struct mach_trap_args *args)
 	    (void *)req->req_address, (long)req->req_size);
 #endif
 
-	SCARG(&cup, addr) = (void *)req->req_address;
-	SCARG(&cup, len) = req->req_size;
+	cup.addr) = (void *)req->req_address;
+	cup.len) = req->req_size;
 
-	if ((error = sys_munmap(tl, &cup, &rep->rep_retval)) != 0)
+	if ((error = sys_munmap(ttd, &cup, &rep->rep_retval)) != 0)
 		return mach_msg_error(args, error);
 
 	*msglen = sizeof(*rep);
@@ -260,7 +258,7 @@ mach_vm_wire(struct mach_trap_args *args)
 	mach_vm_wire_request_t *req = args->smsg;
 	mach_vm_wire_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
-	struct lwp *tl = args->tl;
+	struct thread *ttd = args->ttd;
 	register_t retval;
 	int error;
 
@@ -281,20 +279,20 @@ mach_vm_wire(struct mach_trap_args *args)
 	if (req->req_access == 0) {
 		struct sys_munlock_args cup;
 
-		SCARG(&cup, addr) = (void *)req->req_address;
-		SCARG(&cup, len) = req->req_size;
-		error = sys_munlock(tl, &cup, &retval);
+		cup.addr) = (void *)req->req_address;
+		cup.len) = req->req_size;
+		error = sys_munlock(ttd, &cup, &retval);
 	} else {
 		struct sys_mlock_args cup;
 
-		SCARG(&cup, addr) = (void *)req->req_address;
-		SCARG(&cup, len) = req->req_size;
-		error = sys_mlock(tl, &cup, &retval);
+		cup.addr) = (void *)req->req_address;
+		cup.len) = req->req_size;
+		error = sys_mlock(ttd, &cup, &retval);
 	}
 	if (error != 0)
 		return mach_msg_error(args, error);
 
-	if ((error = uvm_map_protect(&tl->l_proc->p_vmspace->vm_map,
+	if ((error = vm_map_protect(&ttd->td_proc->p_vmspace->vm_map,
 	    req->req_address, req->req_address + req->req_size,
 	    req->req_access, 0)) != 0)
 		return mach_msg_error(args, error);
@@ -313,16 +311,16 @@ mach_vm_protect(struct mach_trap_args *args)
 	mach_vm_protect_request_t *req = args->smsg;
 	mach_vm_protect_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
-	struct lwp *tl = args->tl;
+	struct thread *ttd = args->ttd;
 	struct sys_mprotect_args cup;
 	register_t retval;
 	int error;
 
-	SCARG(&cup, addr) = (void *)req->req_addr;
-	SCARG(&cup, len) = req->req_size;
-	SCARG(&cup, prot) = req->req_prot;
+	cup.addr) = (void *)req->req_addr;
+	cup.len) = req->req_size;
+	cup.prot) = req->req_prot;
 
-	if ((error = sys_mprotect(tl, &cup, &retval)) != 0)
+	if ((error = sys_mprotect(ttd, &cup, &retval)) != 0)
 		return mach_msg_error(args, error);
 
 	*msglen = sizeof(*rep);
@@ -333,7 +331,7 @@ mach_vm_protect(struct mach_trap_args *args)
 }
 
 int
-mach_sys_map_fd(struct lwp *l, const struct mach_sys_map_fd_args *uap, register_t *retval)
+mach_sys_map_fd(struct thread *td, const struct mach_sys_map_fd_args *uap)
 {
 	/* {
 		syscallarg(int) fd;
@@ -346,23 +344,23 @@ mach_sys_map_fd(struct lwp *l, const struct mach_sys_map_fd_args *uap, register_
 	struct vnode *vp;
 	struct exec_vmcmd evc;
 	struct vm_map_entry *ret;
-	struct proc *p = l->l_proc;
+	struct proc *p = td->td_proc;
 	register_t dontcare;
 	struct sys_munmap_args cup;
 	void *va;
 	int error;
 
-	if ((error = copyin(SCARG(uap, va), (void *)&va, sizeof(va))) != 0)
+	if ((error = copyin(uap->va, (void *)&va, sizeof(va))) != 0)
 		return error;
 
-	if (SCARG(uap, findspace) == 0) {
+	if (uap->findspace == 0) {
 		/* Make some free space XXX probably not The Right Way */
-		SCARG(&cup, addr) = va;
-		SCARG(&cup, len) = SCARG(uap, size);
-		(void)sys_munmap(l, &cup, &dontcare);
+		cup.addr = va;
+		cup.len = uap->size;
+		(void)sys_munmap(td, &cup, &dontcare);
 	}
 
-	fp = fd_getfile(SCARG(uap, fd));
+	fp = fd_getfile(uap->fd);
 	if (fp == NULL)
 		return EBADF;
 
@@ -371,32 +369,32 @@ mach_sys_map_fd(struct lwp *l, const struct mach_sys_map_fd_args *uap, register_
 
 #ifdef DEBUG_MACH_VM
 	printf("vm_map_fd: addr = %p len = 0x%08lx\n",
-	    va, (long)SCARG(uap, size));
+		   va, (long)uap->size);
 #endif
 	memset(&evc, 0, sizeof(evc));
 	evc.ev_addr = (u_long)va;
-	evc.ev_len = SCARG(uap, size);
+	evc.ev_len = uap->size;
 	evc.ev_prot = VM_PROT_ALL;
-	evc.ev_flags = SCARG(uap, findspace) ? 0 : VMCMD_FIXED;
+	evc.ev_flags = uap->findspace ? 0 : VMCMD_FIXED;
 	evc.ev_proc = vmcmd_map_readvn;
-	evc.ev_offset = SCARG(uap, offset);
+	evc.ev_offset = uap->offset;
 	evc.ev_vp = vp;
 
 	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY);
-	if ((error = (*evc.ev_proc)(l, &evc)) != 0) {
+	if ((error = (*evc.ev_proc)(td, &evc)) != 0) {
 		VOP_UNLOCK(vp);
 
 #ifdef DEBUG_MACH_VM
 		printf("mach_sys_map_fd: mapping at %p failed\n", va);
 #endif
 
-		if (SCARG(uap, findspace) == 0)
+		if (uap->findspace == 0)
 			goto bad2;
 
 		vm_map_lock(&p->p_vmspace->vm_map);
-		if ((ret = uvm_map_findspace(&p->p_vmspace->vm_map,
+		if ((ret = vm_map_findspace(&p->p_vmspace->vm_map,
 		    vm_map_min(&p->p_vmspace->vm_map), evc.ev_len,
-		    (vaddr_t *)&evc.ev_addr, NULL, 0, PAGE_SIZE, 0)) == NULL) {
+		    (vm_offset_t *)&evc.ev_addr, NULL, 0, PAGE_SIZE, 0)) == NULL) {
 			vm_map_unlock(&p->p_vmspace->vm_map);
 			goto bad2;
 		}
@@ -406,30 +404,30 @@ mach_sys_map_fd(struct lwp *l, const struct mach_sys_map_fd_args *uap, register_
 
 		memset(&evc, 0, sizeof(evc));
 		evc.ev_addr = (u_long)va;
-		evc.ev_len = SCARG(uap, size);
+		evc.ev_len = uap->size;
 		evc.ev_prot = VM_PROT_ALL;
 		evc.ev_flags = 0;
 		evc.ev_proc = vmcmd_map_readvn;
-		evc.ev_offset = SCARG(uap, offset);
+		evc.ev_offset = uap->offset;
 		evc.ev_vp = vp;
 
 #ifdef DEBUG_MACH_VM
 		printf("mach_sys_map_fd: trying at %p\n", va);
 #endif
 		vn_lock(vp, LK_EXCLUSIVE | LK_RETRY);
-		if ((error = (*evc.ev_proc)(l, &evc)) != 0)
+		if ((error = (*evc.ev_proc)(td, &evc)) != 0)
 			goto bad1;
 	}
 
 	vput(vp);
-	fd_putfile(SCARG(uap, fd));
+	fd_putfile(uap->fd);
 #ifdef DEBUG_MACH_VM
 	printf("mach_sys_map_fd: mapping at %p\n", (void *)evc.ev_addr);
 #endif
 
 	va = (mach_vm_offset_t *)evc.ev_addr;
 
-	if ((error = copyout((void *)&va, SCARG(uap, va), sizeof(va))) != 0)
+	if ((error = copyout((void *)&va, uap->va, sizeof(va))) != 0)
 		return error;
 
 	return 0;
@@ -438,7 +436,7 @@ bad1:
 	VOP_UNLOCK(vp);
 bad2:
 	vrele(vp);
-	fd_putfile(SCARG(uap, fd));
+	fd_putfile(uap->fd);
 #ifdef DEBUG_MACH_VM
 	printf("mach_sys_map_fd: mapping at %p failed, error = %d\n",
 	    (void *)evc.ev_addr, error);
@@ -452,17 +450,17 @@ mach_vm_inherit(struct mach_trap_args *args)
 	mach_vm_inherit_request_t *req = args->smsg;
 	mach_vm_inherit_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
-	struct lwp *tl = args->tl;
+	struct thread *ttd = args->ttd;
 	struct sys_minherit_args cup;
 	register_t retval;
 	int error;
 
-	SCARG(&cup, addr) = (void *)req->req_addr;
-	SCARG(&cup, len) = req->req_size;
+	cup.addr) = (void *)req->req_addr;
+	cup.len) = req->req_size;
 	/* Flags map well between Mach and NetBSD */
-	SCARG(&cup, inherit) = req->req_inh;
+	cup.inherit) = req->req_inh;
 
-	if ((error = sys_minherit(tl, &cup, &retval)) != 0)
+	if ((error = sys_minherit(ttd, &cup, &retval)) != 0)
 		return mach_msg_error(args, error);
 
 	*msglen = sizeof(*rep);
@@ -478,8 +476,8 @@ mach_make_memory_entry_64(struct mach_trap_args *args)
 	mach_make_memory_entry_64_request_t *req = args->smsg;
 	mach_make_memory_entry_64_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
-	struct lwp *l = args->l;
-	struct lwp *tl = args->tl;
+	struct thread *td = args->td;
+	struct thread *ttd = args->ttd;
 	struct mach_port *mp;
 	struct mach_right *mr;
 	struct mach_memory_entry *mme;
@@ -491,13 +489,13 @@ mach_make_memory_entry_64(struct mach_trap_args *args)
 	mp->mp_flags |= (MACH_MP_INKERNEL | MACH_MP_DATA_ALLOCATED);
 	mp->mp_datatype = MACH_MP_MEMORY_ENTRY;
 
-	mme = malloc(sizeof(*mme), M_EMULDATA, M_WAITOK);
-	mme->mme_proc = tl->l_proc;
+	mme = malloc(sizeof(*mme), M_MACH, M_WAITOK);
+	mme->mme_proc = td->td_proc;
 	mme->mme_offset = req->req_offset;
 	mme->mme_size = req->req_size;
 	mp->mp_data = mme;
 
-	mr = mach_right_get(mp, l, MACH_PORT_TYPE_SEND, 0);
+	mr = mach_right_get(mp, td, MACH_PORT_TYPE_SEND, 0);
 
 	*msglen = sizeof(*rep);
 	mach_set_header(rep, req, *msglen);
@@ -516,7 +514,7 @@ mach_vm_region(struct mach_trap_args *args)
 	mach_vm_region_request_t *req = args->smsg;
 	mach_vm_region_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
-	struct lwp *tl = args->tl;
+	struct thread *ttd = args->ttd;
 	struct mach_vm_region_basic_info *rbi;
 	struct vm_map *map;
 	struct vm_map_entry *vme;
@@ -536,10 +534,10 @@ mach_vm_region(struct mach_trap_args *args)
 		return mach_msg_error(args, EINVAL);
 	*msglen = sizeof(*rep) + ((req->req_count - 9) * sizeof(int));
 
-	map = &tl->l_proc->p_vmspace->vm_map;
+	map = &td->td_proc->p_vmspace->vm_map;
 
 	vm_map_lock(map);
-	error = uvm_map_lookup_entry(map, req->req_addr, &vme);
+	error = vm_map_lookup_entry(map, req->req_addr, &vme);
 	vm_map_unlock(map);
 
 	if (error == 0)
@@ -574,7 +572,7 @@ mach_vm_region_64(struct mach_trap_args *args)
 	mach_vm_region_64_request_t *req = args->smsg;
 	mach_vm_region_64_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
-	struct lwp *tl = args->tl;
+	struct thread *ttd = args->ttd;
 	struct mach_vm_region_basic_info_64 *rbi;
 	struct vm_map *map;
 	struct vm_map_entry *vme;
@@ -594,10 +592,10 @@ mach_vm_region_64(struct mach_trap_args *args)
 		return mach_msg_error(args, EINVAL);
 	*msglen = sizeof(*rep) + ((req->req_count - 9) * sizeof(int));
 
-	map = &tl->l_proc->p_vmspace->vm_map;
+	map = &td->td_proc->p_vmspace->vm_map;
 
 	vm_map_lock(map);
-	error = uvm_map_lookup_entry(map, req->req_addr, &vme);
+	error = vm_map_lookup_entry(map, req->req_addr, &vme);
 	vm_map_unlock(map);
 
 	if (error == 0)
@@ -631,22 +629,22 @@ mach_vm_msync(struct mach_trap_args *args)
 	mach_vm_msync_request_t *req = args->smsg;
 	mach_vm_msync_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
-	struct lwp *tl = args->tl;
+	struct thread *ttd = args->ttd;
 	struct sys___msync13_args cup;
 	int error;
 	register_t dontcare;
 
-	SCARG(&cup, addr) = (void *)req->req_addr;
-	SCARG(&cup, len) = req->req_size;
-	SCARG(&cup, flags) = 0;
+	cup.addr = (void *)req->req_addr;
+	cup.len = req->req_size;
+	cup.flags = 0;
 	if (req->req_flags & MACH_VM_SYNC_ASYNCHRONOUS)
-		SCARG(&cup, flags) |= MS_ASYNC;
+		cup.flags |= MS_ASYNC;
 	if (req->req_flags & MACH_VM_SYNC_SYNCHRONOUS)
-		SCARG(&cup, flags) |= MS_SYNC;
+		cup.flags |= MS_SYNC;
 	if (req->req_flags & MACH_VM_SYNC_INVALIDATE)
-		SCARG(&cup, flags) |= MS_INVALIDATE;
+		cup.flags |= MS_INVALIDATE;
 
-	error = sys___msync13(tl, &cup, &dontcare);
+	error = sys___msync13(ttd, &cup, &dontcare);
 
 	*msglen = sizeof(*rep);
 	mach_set_header(rep, req, *msglen);
@@ -719,17 +717,17 @@ mach_vm_read(struct mach_trap_args *args)
 	mach_vm_read_request_t *req = args->smsg;
 	mach_vm_read_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
-	struct lwp *l = args->l;
-	struct lwp *tl = args->tl;
+	struct thread *td = args->td;
+	struct thread *ttd = args->ttd;
 	char *tbuf;
 	void *addr;
-	vaddr_t va;
+	vm_offset_t va;
 	size_t size;
 	int error;
 
 	size = req->req_size;
-	va = vm_map_min(&l->l_proc->p_vmspace->vm_map);
-	if ((error = uvm_map(&l->l_proc->p_vmspace->vm_map, &va,
+	va = vm_map_min(&td->td_proc->p_vmspace->vm_map);
+	if ((error = vm_map(&td->td_proc->p_vmspace->vm_map, &va,
 	    round_page(size), NULL, UVM_UNKNOWN_OFFSET, 0,
 	    UVM_MAPFLAG(UVM_PROT_RW, UVM_PROT_ALL,
 	    UVM_INH_COPY, UVM_ADV_NORMAL, UVM_FLAG_COPYONW))) != 0) {
@@ -742,10 +740,10 @@ mach_vm_read(struct mach_trap_args *args)
 	 * This is reasonable for small chunk of data, but we should
 	 * remap COW for areas bigger than a page.
 	 */
-	tbuf = malloc(size, M_EMULDATA, M_WAITOK);
+	tbuf = malloc(size, M_MACH, M_WAITOK);
 
 	addr = (void *)req->req_addr;
-	if ((error = copyin_proc(tl->l_proc, addr, tbuf, size)) != 0) {
+	if ((error = copyin_proc(td->td_proc, addr, tbuf, size)) != 0) {
 		printf("copyin_proc error = %d, addr = %p, size = %x\n", error, addr, size);
 		free(tbuf, M_WAITOK);
 		return mach_msg_error(args, EFAULT);
@@ -779,7 +777,7 @@ mach_vm_write(struct mach_trap_args *args)
 	mach_vm_write_request_t *req = args->smsg;
 	mach_vm_write_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
-	struct lwp *tl = args->tl;
+	struct thread *ttd = args->ttd;
 	size_t size;
 	void *addr;
 	char *tbuf;
@@ -796,7 +794,7 @@ mach_vm_write(struct mach_trap_args *args)
 	 * remap COW for areas bigger than a page.
 	 */
 	size = req->req_data.size;
-	tbuf = malloc(size, M_EMULDATA, M_WAITOK);
+	tbuf = malloc(size, M_MACH, M_WAITOK);
 
 	if ((error = copyin(req->req_data.address, tbuf, size)) != 0) {
 		printf("copyin error = %d\n", error);
@@ -805,7 +803,7 @@ mach_vm_write(struct mach_trap_args *args)
 	}
 
 	addr = (void *)req->req_addr;
-	if ((error = copyout_proc(tl->l_proc, tbuf, addr, size)) != 0) {
+	if ((error = copyout_proc(td->td_proc, tbuf, addr, size)) != 0) {
 		printf("copyout_proc error = %d\n", error);
 		free(tbuf, M_WAITOK);
 		return mach_msg_error(args, EFAULT);
@@ -832,7 +830,7 @@ mach_vm_machine_attribute(struct mach_trap_args *args)
 	mach_vm_machine_attribute_request_t *req = args->smsg;
 	mach_vm_machine_attribute_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
-	struct lwp *tl = args->tl;
+	struct thread *ttd = args->ttd;
 	int error = 0;
 	int attribute, value;
 
@@ -846,7 +844,7 @@ mach_vm_machine_attribute(struct mach_trap_args *args)
 		case MACH_MATTR_VAL_DCACHE_FLUSH:
 		case MACH_MATTR_VAL_ICACHE_FLUSH:
 		case MACH_MATTR_VAL_CACHE_SYNC:
-			error = mach_vm_machine_attribute_machdep(tl,
+			error = mach_vm_machine_attribute_machdep(ttd,
 			    req->req_addr, req->req_size, &value);
 			break;
 		default:
diff --git a/sys/compat/mach/mach_vm.h b/sys/compat/mach/mach_vm.h
index 0c887d9..8f277f7 100644
--- a/sys/compat/mach/mach_vm.h
+++ b/sys/compat/mach/mach_vm.h
@@ -1,4 +1,4 @@
-/*	$NetBSD: mach_vm.h,v 1.30 2008/04/28 20:23:45 martin Exp $ */
+/*	$FreeBSD$ */
 
 /*-
  * Copyright (c) 2002-2003 The NetBSD Foundation, Inc.
@@ -381,11 +381,11 @@ typedef struct {
 
 struct mach_memory_entry {
 	struct proc *mme_proc;
-	vaddr_t	mme_offset;
+	vm_offset_t	mme_offset;
 	size_t mme_size;
 };
 
 /* These are machine dependent functions */
-int mach_vm_machine_attribute_machdep(struct lwp *, vaddr_t, size_t, int *);
+int mach_vm_machine_attribute_machdep(struct td *, vm_offset_t, size_t, int *);
 
 #endif /* _MACH_VM_H_ */
diff --git a/sys/compat/mach/syscalls.conf b/sys/compat/mach/syscalls.conf
index c416d08..86dfb98f 100644
--- a/sys/compat/mach/syscalls.conf
+++ b/sys/compat/mach/syscalls.conf
@@ -1,14 +1,18 @@
-#	$NetBSD: syscalls.conf,v 1.2 2007/12/10 22:32:15 dsl Exp $
+#	$FreeBSD$
 
 sysnames="mach_syscalls.c"
-sysnumhdr="mach_syscall.h"
+sysproto="mach_proto.h"
+sysproto_h=_MACH_SYSPROTO_H_
+syshdr="mach_syscall.h"
 syssw="mach_sysent.c"
-sysarghdr="mach_syscallargs.h"
+sysmk="/dev/null"
+syscallprefix="MACH_SYS_"
 compatopts=""
 libcompatopts=""
 
 switchname="mach_sysent"
 namesname="mach_syscallnames"
+systracte="mach_systrace_args.c"
 constprefix="MACH_SYS_"
 nsysent=128
 maxsysargs=9
diff --git a/sys/compat/mach/syscalls.master b/sys/compat/mach/syscalls.master
index 001a094..9a0433e 100644
--- a/sys/compat/mach/syscalls.master
+++ b/sys/compat/mach/syscalls.master
@@ -1,4 +1,4 @@
-	$NetBSD: syscalls.master,v 1.10 2009/01/13 22:27:43 pooka Exp $
+	$FreeBSD$
 
 ;	@(#)syscalls.master	8.1 (Berkeley) 7/19/93
 
@@ -34,7 +34,6 @@
 
 #if defined(_KERNEL_OPT)
 #include "opt_ntp.h"
-#include "opt_sysv.h"
 #endif
 
 #include <sys/param.h>
@@ -42,54 +41,54 @@
 #include <sys/signal.h>
 #include <sys/mount.h>
 #include <sys/poll.h>
-#include <sys/syscallargs.h>
+#include <sys/sysent.h>
+#include <sys/sysproto.h>
 
 #include <compat/mach/mach_types.h>
 #include <compat/mach/mach_message.h>
 #include <compat/mach/mach_clock.h>
-#include <compat/mach/mach_syscallargs.h>
-%%
+#include <compat/mach/mach_proto.h>
+;;
 
-0	UNIMPL
-1	UNIMPL
-2	UNIMPL
-3	UNIMPL
-4	UNIMPL
-5	UNIMPL
-6	UNIMPL
-7	UNIMPL
-8	UNIMPL
-9	UNIMPL
-10	UNIMPL
-11	UNIMPL
-12	UNIMPL
-13	UNIMPL
-14	UNIMPL
-15	UNIMPL
-16	UNIMPL
-17	UNIMPL
-18	UNIMPL
-19	UNIMPL
-20	UNIMPL
-21	UNIMPL
-22	UNIMPL
-23	UNIMPL
-24	UNIMPL
-25	UNIMPL
-26	STD		{ mach_port_name_t|mach_sys||reply_port(void); }
-27	STD		{ mach_port_name_t|mach_sys||thread_self_trap(void); }
-28	STD		{ mach_port_name_t|mach_sys||task_self_trap(void); }
-29	STD		{ mach_port_name_t|mach_sys||host_self_trap(void); }
-30	UNIMPL
-31	STD		{ mach_msg_return_t|mach_sys||msg_trap( \
-			    mach_msg_header_t	*msg, \
+0  AUE_NULL	UNIMPL	nosys
+1  AUE_NULL	UNIMPL	nosys
+2  AUE_NULL	UNIMPL	nosys
+3  AUE_NULL	UNIMPL	nosys
+4  AUE_NULL	UNIMPL	nosys
+5  AUE_NULL	UNIMPL	nosys
+6  AUE_NULL	UNIMPL	nosys
+7  AUE_NULL	UNIMPL	nosys
+8  AUE_NULL	UNIMPL	nosys
+9  AUE_NULL	UNIMPL	nosys
+10  AUE_NULL	UNIMPL	nosys
+11  AUE_NULL	UNIMPL	nosys
+12  AUE_NULL	UNIMPL	nosys
+13  AUE_NULL	UNIMPL	nosys
+14  AUE_NULL	UNIMPL	nosys
+15  AUE_NULL	UNIMPL	nosys
+16  AUE_NULL	UNIMPL	nosys
+17  AUE_NULL	UNIMPL	nosys
+18  AUE_NULL	UNIMPL	nosys
+19  AUE_NULL	UNIMPL	nosys
+20  AUE_NULL	UNIMPL	nosys
+21  AUE_NULL	UNIMPL	nosys
+22  AUE_NULL	UNIMPL	nosys
+23  AUE_NULL	UNIMPL	nosys
+24  AUE_NULL	UNIMPL	nosys
+25  AUE_NULL	UNIMPL	nosys
+26	AUE_NULL	STD		{ int mach_reply_port(void); }
+27	AUE_NULL	STD		{ int mach_thread_self_trap(void); }
+28	AUE_NULL	STD		{ int mach_task_self_trap(void); }
+29	AUE_NULL	STD		{ int mach_host_self_trap(void); }
+30  AUE_NULL	UNIMPL	nosys
+31	AUE_NULL	STD		{ int mach_msg_trap(mach_msg_header_t	*msg, \
 			    mach_msg_option_t	option, \
 			    mach_msg_size_t	send_size, \
 			    mach_msg_size_t	rcv_size, \
 			    mach_port_name_t	rcv_name, \
 			    mach_msg_timeout_t	timeout, \
 			    mach_port_name_t	notify); }
-32	STD		{ mach_kern_return_t|mach_sys||msg_overwrite_trap( \
+32	AUE_NULL	STD		{ int mach_msg_overwrite_trap( \
 			    mach_msg_header_t	*msg, \
 			    mach_msg_option_t	option, \
 			    mach_msg_size_t	send_size, \
@@ -99,143 +98,129 @@
 			    mach_port_name_t	notify, \
 			    mach_msg_header_t	*rcv_msg, \
 			    mach_msg_size_t	scatter_list_size); }
-33	STD		{ mach_kern_return_t|\
-			    mach_sys||semaphore_signal_trap( \
-			    mach_port_name_t signal_name); }
-34	STD		{ mach_kern_return_t|\
-			    mach_sys||semaphore_signal_all_trap( \
-			    mach_port_name_t signal_name); }
-35	STD		{ mach_kern_return_t|\
-			    mach_sys||semaphore_signal_thread_trap( \
-			    mach_port_name_t signal_name, \
-			    mach_port_name_t thread); }
-36	STD		{ mach_kern_return_t|\
-			    mach_sys||semaphore_wait_trap( \
-			    mach_port_name_t wait_name); }
-37	STD		{ mach_kern_return_t|\
-			    mach_sys||semaphore_wait_signal_trap( \
-			    mach_port_name_t wait_name, \
-			    mach_port_name_t signal_name); }
-38	STD		{ mach_kern_return_t|\
-			    mach_sys||semaphore_timedwait_trap( \
+33	AUE_NULL	STD		{ int mach_semaphore_signal_trap( \
+			  mach_port_name_t signal_name); }
+34	AUE_NULL	STD		{ int mach_semaphore_signal_all_trap( \
+			      mach_port_name_t signal_name); }
+35	AUE_NULL	STD		{ int mach_semaphore_signal_thread_trap( \
+			      	mach_port_name_t signal_name, \
+			    	mach_port_name_t thread); }
+36	AUE_NULL	STD		{ int mach_semaphore_wait_trap( \
+			      mach_port_name_t wait_name); }
+37	AUE_NULL	STD		{ int mach_semaphore_wait_signal_trap( \
+			      mach_port_name_t wait_name, \
+			      mach_port_name_t signal_name); }
+38	AUE_NULL	STD		{ int mach_semaphore_timedwait_trap( \
 			    mach_port_name_t wait_name, \
 			    unsigned int sec, \
 			    mach_clock_res_t nsec); }
-39	STD		{ mach_kern_return_t|\
-			    mach_sys||semaphore_timedwait_signal_trap( \
+39	AUE_NULL	STD		{ int mach_semaphore_timedwait_signal_trap( \
 			    mach_port_name_t wait_name, \
 			    mach_port_name_t signal_name, \
 			    unsigned int sec, \
 			    mach_clock_res_t nsec); }
-40	UNIMPL
-41	STD		{ mach_kern_return_t|mach_sys||init_process(void); }
-42	UNIMPL
-43	STD		{ mach_kern_return_t|mach_sys||map_fd(int fd, \
+40  AUE_NULL	UNIMPL	nosys
+41	AUE_NULL	STD		{ int mach_init_process(void); }
+42  AUE_NULL	UNIMPL	nosys
+43	AUE_NULL	STD		{ int mach_map_fd(int fd, \
 			    mach_vm_offset_t offset, mach_vm_offset_t *va, \
 			    mach_boolean_t findspace, mach_vm_size_t size); }
-44	UNIMPL
-45	STD		{ mach_kern_return_t|mach_sys||task_for_pid( \
+44  AUE_NULL	UNIMPL	nosys
+45	AUE_NULL	STD		{ int mach_task_for_pid( \
 			    mach_port_t target_tport, int pid, \
 			    mach_port_t *t); }
-46	STD		{ mach_kern_return_t|mach_sys||pid_for_task( \
+46	AUE_NULL	STD		{ int mach_pid_for_task( \
 			    mach_port_t t, int *x); }
-47	UNIMPL
-48	STD		{ mach_kern_return_t|mach_sys||macx_swapon( \
+47  AUE_NULL	UNIMPL	nosys
+48	AUE_NULL	STD		{ int mach_macx_swapon( \
 			    char *name, int flags, int size, int priority); }
-49	STD		{ mach_kern_return_t|mach_sys||macx_swapoff( \
+49	AUE_NULL	STD		{ int mach_macx_swapoff( \
 			    char *name, int flags); }
-50	UNIMPL
-51	STD		{ mach_kern_return_t|mach_sys||macx_triggers( \
-			    int hi_water, int low_water, int flags, \
-			    mach_port_t alert_port); }
-52	UNIMPL
-53	UNIMPL
-54	UNIMPL
-55	UNIMPL
-56	UNIMPL
-57	UNIMPL
-58	UNIMPL
-59	STD		{ mach_kern_return_t|mach_sys||swtch_pri( \
-			    int pri); }
-60	STD		{ mach_kern_return_t|mach_sys||swtch(void); }
-61	STD		{ mach_kern_return_t|mach_sys||syscall_thread_switch( \
+50  AUE_NULL	UNIMPL	nosys
+51	AUE_NULL	STD		{ int mach_macx_triggers(int hi_water, int low_water, \
+			  	  int flags, mach_port_t alert_port); }
+52  AUE_NULL	UNIMPL	nosys
+53  AUE_NULL	UNIMPL	nosys
+54  AUE_NULL	UNIMPL	nosys
+55  AUE_NULL	UNIMPL	nosys
+56  AUE_NULL	UNIMPL	nosys
+57  AUE_NULL	UNIMPL	nosys
+58  AUE_NULL	UNIMPL	nosys
+59	AUE_NULL	STD		{ int mach_swtch_pri(int pri); }
+60	AUE_NULL	STD		{ int mach_swtch(void); }
+61	AUE_NULL	STD		{ int mach_syscall_thread_switch( \
 			    mach_port_name_t thread_name, \
 			    int option, \
 			    mach_msg_timeout_t option_time); }
-62	STD		{ mach_kern_return_t|mach_sys||clock_sleep_trap( \
+62	AUE_NULL	STD		{ int mach_clock_sleep_trap( \
 			    mach_port_name_t clock_name, \
 			    mach_sleep_type_t sleep_type, \
 			    int sleep_sec, int sleep_nsec, \
 			    mach_timespec_t *wakeup_time); }
-63	UNIMPL
-64	UNIMPL
-65	UNIMPL
-66	UNIMPL
-67	UNIMPL
-68	UNIMPL
-69	UNIMPL
-70	UNIMPL
-71	UNIMPL
-72	UNIMPL
-73	UNIMPL
-74	UNIMPL
-75	UNIMPL
-76	UNIMPL
-77	UNIMPL
-78	UNIMPL
-79	UNIMPL
-80	UNIMPL
-81	UNIMPL
-82	UNIMPL
-83	UNIMPL
-84	UNIMPL
-85	UNIMPL
-86	UNIMPL
-87	UNIMPL
-88	UNIMPL
-89	STD		{ mach_kern_return_t|mach_sys||timebase_info( \
-			    mach_timebase_info_t info); }
-90	STD		{ mach_kern_return_t|mach_sys||wait_until( \
-			    u_int64_t deadline); }
-91	STD		{ mach_port_name_t|mach_sys||timer_create(void); }
-92	STD		{ mach_kern_return_t|mach_sys||timer_destroy( \
-			    mach_port_name_t name); }
-93	STD		{ mach_kern_return_t|mach_sys||timer_arm( \
-			    mach_port_name_t name, \
-			    mach_absolute_time_t expire_time); }
-94	STD		{ mach_kern_return_t|mach_sys||timer_cancel( \
-			    mach_port_name_t name, \
-			    mach_absolute_time_t *result_time); }
-95	STD		{ mach_kern_return_t|mach_sys||get_time_base_info(void); }
-96	UNIMPL
-97	UNIMPL
-98	UNIMPL
-99	UNIMPL
-100	UNIMPL
-101	UNIMPL
-102	UNIMPL
-103	UNIMPL
-104	UNIMPL
-105	UNIMPL
-106	UNIMPL
-107	UNIMPL
-108	UNIMPL
-109	UNIMPL
-110	UNIMPL
-111	UNIMPL
-112	UNIMPL
-113	UNIMPL
-114	UNIMPL
-115	UNIMPL
-116	UNIMPL
-117	UNIMPL
-118	UNIMPL
-119	UNIMPL
-120	UNIMPL
-121	UNIMPL
-122	UNIMPL
-123	UNIMPL
-124	UNIMPL
-125	UNIMPL
-126	UNIMPL
-127	UNIMPL
+63  AUE_NULL	UNIMPL	nosys
+64  AUE_NULL	UNIMPL	nosys
+65  AUE_NULL	UNIMPL	nosys
+66  AUE_NULL	UNIMPL	nosys
+67  AUE_NULL	UNIMPL	nosys
+68  AUE_NULL	UNIMPL	nosys
+69  AUE_NULL	UNIMPL	nosys
+70  AUE_NULL	UNIMPL	nosys
+71  AUE_NULL	UNIMPL	nosys
+72  AUE_NULL	UNIMPL	nosys
+73  AUE_NULL	UNIMPL	nosys
+74  AUE_NULL	UNIMPL	nosys
+75  AUE_NULL	UNIMPL	nosys
+76  AUE_NULL	UNIMPL	nosys
+77  AUE_NULL	UNIMPL	nosys
+78  AUE_NULL	UNIMPL	nosys
+79  AUE_NULL	UNIMPL	nosys
+80  AUE_NULL	UNIMPL	nosys
+81  AUE_NULL	UNIMPL	nosys
+82  AUE_NULL	UNIMPL	nosys
+83  AUE_NULL	UNIMPL	nosys
+84  AUE_NULL	UNIMPL	nosys
+85  AUE_NULL	UNIMPL	nosys
+86  AUE_NULL	UNIMPL	nosys
+87  AUE_NULL	UNIMPL	nosys
+88  AUE_NULL	UNIMPL	nosys
+89	AUE_NULL	STD		{ int mach_timebase_info(mach_timebase_info_t info); }
+90	AUE_NULL	STD		{ int mach_wait_until(uint64_t deadline); }
+91	AUE_NULL	STD		{ int mach_timer_create(void); }
+92	AUE_NULL	STD		{ int mach_timer_destroy(mach_port_name_t name); }
+93	AUE_NULL	STD		{ int mach_timer_arm(mach_port_name_t name, \
+			      			mach_absolute_time_t expire_time); }
+94	AUE_NULL	STD		{ int mach_timer_cancel(mach_port_name_t name, \
+			    		mach_absolute_time_t *result_time); }
+95	AUE_NULL	STD		{ int mach_get_time_base_info(void); }
+96  AUE_NULL	UNIMPL	nosys
+97  AUE_NULL	UNIMPL	nosys
+98  AUE_NULL	UNIMPL	nosys
+99  AUE_NULL	UNIMPL	nosys
+100  AUE_NULL	UNIMPL	nosys
+101  AUE_NULL	UNIMPL	nosys
+102  AUE_NULL	UNIMPL	nosys
+103  AUE_NULL	UNIMPL	nosys
+104  AUE_NULL	UNIMPL	nosys
+105  AUE_NULL	UNIMPL	nosys
+106  AUE_NULL	UNIMPL	nosys
+107  AUE_NULL	UNIMPL	nosys
+108  AUE_NULL	UNIMPL	nosys
+109  AUE_NULL	UNIMPL	nosys
+110  AUE_NULL	UNIMPL	nosys
+111  AUE_NULL	UNIMPL	nosys
+112  AUE_NULL	UNIMPL	nosys
+113  AUE_NULL	UNIMPL	nosys
+114  AUE_NULL	UNIMPL	nosys
+115  AUE_NULL	UNIMPL	nosys
+116  AUE_NULL	UNIMPL	nosys
+117  AUE_NULL	UNIMPL	nosys
+118  AUE_NULL	UNIMPL	nosys
+119  AUE_NULL	UNIMPL	nosys
+120  AUE_NULL	UNIMPL	nosys
+121  AUE_NULL	UNIMPL	nosys
+122  AUE_NULL	UNIMPL	nosys
+123  AUE_NULL	UNIMPL	nosys
+124  AUE_NULL	UNIMPL	nosys
+125  AUE_NULL	UNIMPL	nosys
+126  AUE_NULL	UNIMPL	nosys
+127  AUE_NULL	UNIMPL	nosys
